import React from 'react';
import { Modal, Icon } from 'rlj-design';
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/picturePreview.less";
var prefixCls = "".concat(PREFIX_CLS, "-picturePreview");

var PicturePreview = function PicturePreview(_ref) {
  var visible = _ref.visible,
      imgSrc = _ref.imgSrc,
      setVisible = _ref.setVisible;
  return /*#__PURE__*/React.createElement(Modal, {
    width: "100%",
    className: prefixCls,
    open: visible,
    closable: false,
    footer: null
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content-actionBar")
  }, /*#__PURE__*/React.createElement("a", {
    href: imgSrc
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "download",
    className: "".concat(prefixCls, "-actionIcon")
  })), /*#__PURE__*/React.createElement(Icon, {
    type: "close",
    className: "".concat(prefixCls, "-actionIcon"),
    onClick: function onClick() {
      return setVisible(false);
    }
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content-image")
  }, /*#__PURE__*/React.createElement("img", {
    src: imgSrc,
    alt: "\u56FE\u7247\u52A0\u8F7D\u5931\u8D25"
  }))));
};

export default PicturePreview;