/// <reference types="react" />
import type { UploadProps } from 'rlj-design';
export interface FilesProps {
    time?: string;
    size?: string | number;
    fileName: string;
}
export interface AttachmentUploadProps extends Omit<UploadProps, 'itemRender'> {
    value?: FilesProps[];
    disabled?: boolean;
    owner?: string;
    size?: number;
    uploadClassName?: string;
    itemRender?: (url: string) => React.ReactNode;
    itemRenderClick?: (url: string) => void;
    fileUrlHandle?: (state: 'preview' | 'download', fileInfo: FilesProps) => string;
    showOperationBtn?: boolean;
    showUploadBtn?: boolean;
    showLoading?: boolean;
    runLoading?: (loading: boolean) => void;
    resultHandle?: (res: any) => {
        errorCode: string | null;
        errorMsg: string | null;
        success: boolean;
        data?: {
            files: FilesProps[];
        } | {};
    };
}
export interface PicturePreviewProps {
    visible: boolean;
    imgSrc: string;
    setVisible: (visible: boolean) => void;
    open?: boolean;
}
