var _excluded = ["children", "disabled"],
    _excluded2 = ["scopeFields", "drawerProps", "btnText", "btnRender", "detailRender", "DDPickerProps", "CCPickerProps", "disabled", "needShowSelectEmp"];

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useState } from 'react';
import { Form, Button, Icon, Drawer } from 'rlj-design';
import { StoreContext } from "./hooks";
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import { ScopeItem, ScopeDetail } from "./components/ScopeItem";
import { ScopeFormListItem } from "./components/ScopeFormListItem";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-conditionSetting");
var Item = Form.Item,
    List = Form.List;
export var ItemBtn = function ItemBtn(_ref) {
  var children = _ref.children,
      disabled = _ref.disabled,
      restProps = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement("div", _extends({
    className: "".concat(prefixCls, "-radioItemButton")
  }, restProps), /*#__PURE__*/React.createElement(Button, {
    type: "link",
    noPadding: true,
    icon: /*#__PURE__*/React.createElement(Icon, {
      type: "add",
      size: 14
    }),
    stop: false,
    disabled: disabled
  }, children));
};

var ConditionSetting = function ConditionSetting(props) {
  var scopeFields = props.scopeFields,
      drawerProps = props.drawerProps,
      _props$btnText = props.btnText,
      btnText = _props$btnText === void 0 ? '添加规则' : _props$btnText,
      btnRender = props.btnRender,
      detailRender = props.detailRender,
      DDPickerProps = props.DDPickerProps,
      CCPickerProps = props.CCPickerProps,
      disabled = props.disabled,
      _props$needShowSelect = props.needShowSelectEmp,
      needShowSelectEmp = _props$needShowSelect === void 0 ? false : _props$needShowSelect,
      restProps = _objectWithoutProperties(props, _excluded2);

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var validateFields = form.validateFields,
      resetFields = form.resetFields,
      setFieldValue = form.setFieldValue;

  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      scopeList = _useState4[0],
      setScopeList = _useState4[1];

  useEffect(function () {
    var _ref2 = restProps,
        value = _ref2.value;
    if (value === undefined) return;
    setScopeList(value);
  }, [restProps]);

  var scopeListChange = function scopeListChange(scopeList) {
    var onChange = restProps === null || restProps === void 0 ? void 0 : restProps.onChange;

    if (scopeList.length && onChange) {
      onChange(scopeList);
    }
  };

  var onRealFinish = function onRealFinish() {
    validateFields().then(function (values) {
      var scopeList = values.scopeList;
      setScopeList(_toConsumableArray(scopeList));
      scopeListChange(scopeList);
      setOpen(false);
    }).catch(function (error) {
      console.error(error);
    });
  }; // 点击添加范围，清除当前添加范围抽屉的数据，默认添加一条空范围条件


  var openAddScope = function openAddScope() {
    if (disabled) return;
    setOpen(true);
    resetFields();
    setFieldValue(['scopeList'], [undefined]);
  }; // 点击人员范围条件打开范围选择框


  var openEditScope = function openEditScope() {
    Promise.resolve(setOpen(true)).then(function () {
      setFieldValue(['scopeList'], scopeList);
    });
  };

  var getRender = function getRender() {
    var btn = btnRender || /*#__PURE__*/React.createElement(ItemBtn, {
      onClick: openAddScope,
      disabled: disabled
    }, btnText);
    var detail = detailRender || /*#__PURE__*/React.createElement(ScopeItem, {
      onClickChange: openEditScope,
      disabled: disabled
    }, scopeList.map(function (_ref3, index) {
      var fields = _ref3.fields;
      return /*#__PURE__*/React.createElement("div", {
        key: index
      }, /*#__PURE__*/React.createElement(ScopeDetail, {
        fields: fields
      }), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-personScopeText")
      }, index !== (scopeList === null || scopeList === void 0 ? void 0 : scopeList.length) - 1 && '或满足'));
    }));
    return /*#__PURE__*/React.createElement("div", {
      className: classnames(_defineProperty({}, "".concat(prefixCls, "-disabled"), disabled))
    }, !(scopeList !== null && scopeList !== void 0 && scopeList.length) ? btn : detail);
  };

  var contextValue = {
    scopeFields: scopeFields,
    DDPickerProps: DDPickerProps,
    scopeList: scopeList,
    CCPickerProps: CCPickerProps,
    needShowSelectEmp: needShowSelectEmp
  };
  return /*#__PURE__*/React.createElement(StoreContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-addPeopleDrawer")
  }, getRender(), /*#__PURE__*/React.createElement(Drawer, _extends({
    titleName: "\u6761\u4EF6\u8BBE\u7F6E",
    width: 516,
    closable: false,
    onClose: function onClose() {
      return setOpen(false);
    },
    open: open,
    onFinish: onRealFinish,
    loading: false,
    destroyOnClose: false
  }, drawerProps), /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "person-scope",
    onFinish: onRealFinish,
    autoComplete: "off",
    style: {
      overflow: 'hidden'
    }
  }, /*#__PURE__*/React.createElement(List, {
    name: "scopeList"
  }, function (fields, _ref4) {
    var add = _ref4.add,
        remove = _ref4.remove;
    return /*#__PURE__*/React.createElement(React.Fragment, null, fields.map(function (item, i) {
      return /*#__PURE__*/React.createElement("span", {
        key: item.key
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-personScopeText")
      }, i > 0 && '或满足'), /*#__PURE__*/React.createElement(ScopeFormListItem, {
        index: i,
        listLength: fields === null || fields === void 0 ? void 0 : fields.length,
        remove: remove
      }));
    }), /*#__PURE__*/React.createElement(Item, {
      style: {
        marginTop: 12
      }
    }, /*#__PURE__*/React.createElement(Button, {
      type: "dashed",
      icon: /*#__PURE__*/React.createElement(Icon, {
        type: "add"
      }),
      style: {
        width: '100%'
      },
      onClick: function onClick() {
        return add();
      },
      iconColor: "#7f7f85"
    }, "\u6DFB\u52A0\u6761\u4EF6\u7EC4")));
  })))));
};

export default ConditionSetting;