var _excluded = ["add", "remove"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState } from 'react';
import { Icon, Form, Button, Tooltip } from 'rlj-design';
import { useStoreContext } from "../../hooks";
import { PREFIX_CLS } from "../../../constants/dictionary";
import ScopeValue from "../ScopeValue";
import "./index.less";
var Item = Form.Item,
    List = Form.List;
var prefixCls = "".concat(PREFIX_CLS, "-scopeFormListItem");
export var ScopeFormListItem = function ScopeFormListItem(_ref) {
  var index = _ref.index,
      remove = _ref.remove,
      listLength = _ref.listLength;

  var _useStoreContext = useStoreContext(),
      scopeList = _useStoreContext.scopeList;

  var _Form$useFormInstance = Form.useFormInstance(),
      validateFields = _Form$useFormInstance.validateFields,
      setFieldValue = _Form$useFormInstance.setFieldValue;

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      selected = _useState2[0],
      setSelected = _useState2[1];

  var addNewItem = function addNewItem(add, fields) {
    // 这里遍历一下所有需要触发校验的字段，不然的话点击添加会触发每一个字段的校验
    var nameList = fields.reduce(function (total, _ref2) {
      var name = _ref2.name;
      return total.concat([['scopeList', index, 'fields', name, 'option'], ['scopeList', index, 'fields', name, 'value']]);
    }, []);
    validateFields(nameList).then(function () {
      add();
    }).catch(function (error) {
      console.log(error);
    });
  };

  useEffect(function () {
    var _scopeList$index, _scopeList$index$fiel;

    if ((_scopeList$index = scopeList[index]) !== null && _scopeList$index !== void 0 && (_scopeList$index$fiel = _scopeList$index.fields) !== null && _scopeList$index$fiel !== void 0 && _scopeList$index$fiel.length) {
      var _scopeList$index2;

      setFieldValue(['scopeList', index, 'fields'], (_scopeList$index2 = scopeList[index]) === null || _scopeList$index2 === void 0 ? void 0 : _scopeList$index2.fields);
    } else {
      setFieldValue(['scopeList', index, 'fields'], [undefined]);
    }
  }, []);
  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement("p", null, "\u6761\u4EF6\u7EC4 ", index + 1, listLength > 1 && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-scopeFormListDelete"),
    onClick: function onClick() {
      remove(index);
      selected.splice(index, 1);
      setSelected(_toConsumableArray(selected));
    }
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "delete"
  }))), /*#__PURE__*/React.createElement("main", null, /*#__PURE__*/React.createElement(List, {
    name: [index, 'fields']
  }, function (fields, _ref3) {
    var add = _ref3.add,
        remove = _ref3.remove,
        restProps = _objectWithoutProperties(_ref3, _excluded);

    return /*#__PURE__*/React.createElement(React.Fragment, null, fields.map(function (item, i) {
      return /*#__PURE__*/React.createElement("span", {
        key: item.key
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-scopeFormListItemText")
      }, /*#__PURE__*/React.createElement("span", null, i === 0 ? '当' : '且'), fields.length > 1 && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-scopeFormListDelete"),
        onClick: function onClick() {
          remove(item.name);
          selected.splice(i, 1);
          setSelected(_toConsumableArray(selected));
        }
      }, /*#__PURE__*/React.createElement(Icon, {
        type: "delete"
      }))), /*#__PURE__*/React.createElement(ScopeValue, _extends({
        index: index,
        item: item,
        selected: selected,
        setSelected: setSelected
      }, restProps)));
    }), /*#__PURE__*/React.createElement(Item, {
      style: {
        margin: 0,
        width: 100
      }
    }, /*#__PURE__*/React.createElement(Tooltip, {
      title: selected.includes('empId') ? '人员不能和其他字段同时选择' : '',
      placement: "topLeft"
    }, /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(Button, {
      className: "".concat(prefixCls, "-addBtn"),
      type: "link",
      icon: /*#__PURE__*/React.createElement(Icon, {
        type: "add"
      }),
      onClick: function onClick() {
        return addNewItem(add, fields);
      },
      noPadding: true,
      disabled: selected.includes('empId')
    }, "\u6DFB\u52A0\u6761\u4EF6")))));
  })));
};