var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { Checkbox, Icon, Space, Tooltip, Button } from 'rlj-design';
import { error_color, warning_color } from "../../constants/dictionary";
import styled from 'styled-components';

var ModalWrapper = function ModalWrapper(props) {
  var _infoConf$value, _infoConf$icon, _props$cancelProps, _props$cancelProps2, _props$cancelProps3, _props$cancelProps4, _props$cancelProps$te, _props$cancelProps5, _props$okProps, _props$okProps2, _props$okProps$danger, _props$okProps3, _props$okProps$text, _props$okProps4;

  var content = props.content,
      errMsg = props.errMsg,
      errMsgConf = props.errMsgConf,
      infoConf = props.infoConf,
      type = props.type,
      title = props.title;

  var _useState = useState((_infoConf$value = infoConf === null || infoConf === void 0 ? void 0 : infoConf.value) !== null && _infoConf$value !== void 0 ? _infoConf$value : false),
      _useState2 = _slicedToArray(_useState, 2),
      confirmInfoValue = _useState2[0],
      setConfirmInfoValue = _useState2[1];

  var isError = type === 'error';
  return /*#__PURE__*/React.createElement(WrapperDivSty, null, isError ? /*#__PURE__*/React.createElement(TitleIconSty, {
    type: "closeAreality",
    size: 22,
    color: error_color
  }) : /*#__PURE__*/React.createElement(TitleIconSty, {
    type: "warningAreality",
    size: 22,
    color: warning_color
  }), /*#__PURE__*/React.createElement(TitleDivSty, null, title || '-'), /*#__PURE__*/React.createElement(WrapperContentDivSty, null, content && /*#__PURE__*/React.createElement(ContentDivSty, null, content), errMsg && /*#__PURE__*/React.createElement(DescDivSty, null, errMsg), errMsgConf && /*#__PURE__*/React.createElement("div", {
    style: {
      maxHeight: 150,
      overflowY: 'auto'
    }
  }, /*#__PURE__*/React.createElement(Space, {
    direction: "vertical",
    size: errMsgConf.isBlockSize ? errMsgConf.blockSize || 8 : 0,
    style: {
      width: '100%'
    }
  }, typeof errMsg === 'string' ? /*#__PURE__*/React.createElement(DescDivSty, null, errMsg) : errMsgConf.value.map(function (v, i) {
    return /*#__PURE__*/React.createElement(DescDivSty, {
      pd: errMsgConf.isBlockSize ? '8px' : i === 0 ? '8px ' : '0 8px 8px'
    }, /*#__PURE__*/React.createElement(Space, {
      align: "start",
      direction: errMsgConf.itemDirection || 'horizontal',
      size: 0
    }, v.label && /*#__PURE__*/React.createElement("div", {
      style: {
        color: '#7f7f85',
        whiteSpace: 'nowrap'
      }
    }, v.label, "\uFF1A"), /*#__PURE__*/React.createElement("div", {
      style: {
        color: '#262626'
      }
    }, v.value)));
  }))), infoConf && /*#__PURE__*/React.createElement(InfoDivSty, null, /*#__PURE__*/React.createElement(Checkbox, {
    checked: confirmInfoValue,
    onChange: function onChange(e) {
      return setConfirmInfoValue(e.target.checked);
    }
  }, /*#__PURE__*/React.createElement("span", null, infoConf.label)), /*#__PURE__*/React.createElement(Tooltip, {
    title: infoConf.tips
  }, /*#__PURE__*/React.createElement(InfoIconSty, {
    type: (_infoConf$icon = infoConf.icon) !== null && _infoConf$icon !== void 0 ? _infoConf$icon : 'explain'
  })))), /*#__PURE__*/React.createElement(WrapperFooterDivSty, null, /*#__PURE__*/React.createElement(Space, null, (isError ? !!((_props$cancelProps = props.cancelProps) !== null && _props$cancelProps !== void 0 && _props$cancelProps.show) : ((_props$cancelProps2 = props.cancelProps) === null || _props$cancelProps2 === void 0 ? void 0 : _props$cancelProps2.show) !== false) && /*#__PURE__*/React.createElement(Button, {
    onClick: function onClick() {
      var _props$onCancel;

      return props === null || props === void 0 ? void 0 : (_props$onCancel = props.onCancel) === null || _props$onCancel === void 0 ? void 0 : _props$onCancel.call(props);
    },
    type: props === null || props === void 0 ? void 0 : (_props$cancelProps3 = props.cancelProps) === null || _props$cancelProps3 === void 0 ? void 0 : _props$cancelProps3.type,
    danger: props === null || props === void 0 ? void 0 : (_props$cancelProps4 = props.cancelProps) === null || _props$cancelProps4 === void 0 ? void 0 : _props$cancelProps4.danger
  }, (_props$cancelProps$te = (_props$cancelProps5 = props.cancelProps) === null || _props$cancelProps5 === void 0 ? void 0 : _props$cancelProps5.text) !== null && _props$cancelProps$te !== void 0 ? _props$cancelProps$te : '取 消'), ((_props$okProps = props.okProps) === null || _props$okProps === void 0 ? void 0 : _props$okProps.show) !== false && /*#__PURE__*/React.createElement(Button, {
    onClick: function onClick() {
      var _props$onOk;

      return props === null || props === void 0 ? void 0 : (_props$onOk = props.onOk) === null || _props$onOk === void 0 ? void 0 : _props$onOk.call(props, confirmInfoValue);
    },
    type: (props === null || props === void 0 ? void 0 : (_props$okProps2 = props.okProps) === null || _props$okProps2 === void 0 ? void 0 : _props$okProps2.type) || 'primary',
    danger: (_props$okProps$danger = props === null || props === void 0 ? void 0 : (_props$okProps3 = props.okProps) === null || _props$okProps3 === void 0 ? void 0 : _props$okProps3.danger) !== null && _props$okProps$danger !== void 0 ? _props$okProps$danger : isError
  }, (_props$okProps$text = (_props$okProps4 = props.okProps) === null || _props$okProps4 === void 0 ? void 0 : _props$okProps4.text) !== null && _props$okProps$text !== void 0 ? _props$okProps$text : isError ? '删 除' : '确 定'))));
};

export { ModalWrapper };
var WrapperDivSty = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  margin-top: 4px;\n"])));
var WrapperContentDivSty = styled.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  margin-top: 12px;\n  margin-left: 38px;\n"])));
var WrapperFooterDivSty = styled.div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  text-align: right;\n  margin-top: 24px;\n"])));
var TitleIconSty = styled(Icon)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  font-size: 22px;\n  float: left;\n  margin-right: 16px;\n"])));
var TitleDivSty = styled.div(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  overflow: hidden;\n  color: rgba(0, 0, 0, 0.85);\n  font-weight: bold;\n  font-size: 16px;\n  line-height: 1.4;\n"])));
var ContentDivSty = styled.div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n  font-size: 14px;\n  color: #7f7f85;\n  text-align: justify;\n  word-break: break-all;\n  line-height: 22px;\n  margin-bottom: 12px;\n"])));
var DescDivSty = styled.div(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n  background: #f2f4f8;\n  border-radius: 2px;\n  font-size: 14px;\n  color: #7f7f85;\n  text-align: justify;\n  word-break: break-all;\n  line-height: 22px;\n  padding: ", ";\n"])), function (p) {
  return p.pd || '8px';
});
var InfoIconSty = styled(Icon)(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["\n  color: #747677;\n  font-size: 16px;\n  &:hover {\n    color: #262626;\n  }\n"])));
var InfoDivSty = styled.div(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["\n  display: flex;\n  align-items: center;\n  justify-content: flex-start;\n  margin-top: 12px;\n"])));