function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import React, { useMemo, useRef } from 'react';
import { Checkbox, Typography } from 'rlj-design';
import { useStoreContext } from "../hooks";
import { useFieldsToOptions } from "../hooks";
import { PREFIX_CLS } from "../../constants/dictionary";
import "../style/fieldCheckbox.less";
var CheckboxGroup = Checkbox.Group;
var TextOverFlow = Typography.TextOverFlow;

var getFilterData = function getFilterData(data, selectFieldId) {
  return (data === null || data === void 0 ? void 0 : data.filter(function (item) {
    var fieldId = item.fieldId,
        fieldDisabled = item.fieldDisabled,
        _item$checkable = item.checkable,
        checkable = _item$checkable === void 0 ? true : _item$checkable;
    return !fieldDisabled && checkable || (selectFieldId === null || selectFieldId === void 0 ? void 0 : selectFieldId.includes(fieldId));
  }).map(function (item) {
    return item.fieldId;
  })) || [];
};

var FieldItem = function FieldItem(props) {
  var prefixCls = "".concat(PREFIX_CLS, "-fieldMultipleCheckbox");

  var _useStoreContext = useStoreContext(),
      checkedValueMap = _useStoreContext.checkedValueMap,
      setCheckedValueMap = _useStoreContext.setCheckedValueMap,
      isMultipleDragGroup = _useStoreContext.isMultipleDragGroup;

  var groupId = props.groupId,
      groupName = props.groupName,
      children = props.children,
      groupDisabled = props.groupDisabled,
      fieldId = props.fieldId;
  var key = isMultipleDragGroup ? groupId || fieldId : 'group';
  var lastChecked = useRef(false);

  var groupOnChange = function groupOnChange(e) {
    var _e$target = e.target,
        value = _e$target.value,
        checked = _e$target.checked;
    var selectFieldId = checkedValueMap.get(key) || [];

    if (checked) {
      checkedValueMap.set(key, selectFieldId.concat([value]));
    } else {
      var data = selectFieldId.filter(function (item) {
        return item !== value;
      });

      if (data !== null && data !== void 0 && data.length) {
        checkedValueMap.set(key, data);
      } else {
        checkedValueMap.delete(key);
      }
    }

    lastChecked.current = false;
    setCheckedValueMap(new Map(checkedValueMap));
  };

  var options = useFieldsToOptions(children, groupOnChange);

  var checkedAllOnChange = function checkedAllOnChange(e) {
    var checked = e.target.checked;
    var selectFieldId = checkedValueMap.get(key) || [];

    if (checked && !lastChecked.current) {
      var selectFields = getFilterData(children, selectFieldId);
      checkedValueMap.set(key, Array.from(new Set(selectFieldId.concat(selectFields))));
      lastChecked.current = true;
    } else {
      var restChild = children === null || children === void 0 ? void 0 : children.filter(function (_ref) {
        var fieldDisabled = _ref.fieldDisabled,
            _ref$checkable = _ref.checkable,
            checkable = _ref$checkable === void 0 ? true : _ref$checkable;
        return !fieldDisabled && checkable;
      }).map(function (_ref2) {
        var fieldId = _ref2.fieldId;
        return fieldId;
      });

      var _selectFields = selectFieldId === null || selectFieldId === void 0 ? void 0 : selectFieldId.filter(function (fieldId) {
        return !(restChild !== null && restChild !== void 0 && restChild.includes(fieldId));
      });

      if (_selectFields !== null && _selectFields !== void 0 && _selectFields.length) {
        checkedValueMap.set(key, _selectFields);
      } else {
        checkedValueMap.delete(key);
      }

      lastChecked.current = false;
    }

    setCheckedValueMap(new Map(checkedValueMap));
  };

  var _useMemo = useMemo(function () {
    var selectFieldId = checkedValueMap.get(key) || [];

    var fun = function fun(_ref3) {
      var fieldId = _ref3.fieldId;
      return selectFieldId.includes(fieldId || groupId || '');
    };

    var checkedAll = children === null || children === void 0 ? void 0 : children.every(fun);
    var indeterminate = (children === null || children === void 0 ? void 0 : children.some(fun)) && !checkedAll;
    return {
      indeterminate: indeterminate,
      checkedAll: checkedAll
    };
  }, [checkedValueMap]),
      indeterminate = _useMemo.indeterminate,
      checkedAll = _useMemo.checkedAll;

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-container-item")
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      width: 135
    }
  }, groupId && /*#__PURE__*/React.createElement(Checkbox, {
    disabled: groupDisabled,
    indeterminate: indeterminate,
    checked: checkedAll,
    onChange: checkedAllOnChange
  }, /*#__PURE__*/React.createElement(TextOverFlow, {
    width: 100
  }, groupName))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(CheckboxGroup, {
    options: options,
    value: checkedValueMap.get(key)
  })));
};

export var FieldMultipleCheckbox = function FieldMultipleCheckbox() {
  var prefixCls = "".concat(PREFIX_CLS, "-fieldMultipleCheckbox");

  var _useStoreContext2 = useStoreContext(),
      checkedValueMap = _useStoreContext2.checkedValueMap,
      setCheckedValueMap = _useStoreContext2.setCheckedValueMap,
      fieldsData = _useStoreContext2.fieldsData,
      disableFields = _useStoreContext2.disableFields,
      isMultipleDragGroup = _useStoreContext2.isMultipleDragGroup;

  var lastChecked = useRef(false);

  var checkedAllOnChange = function checkedAllOnChange(e) {
    var checked = e.target.checked;

    if (checked && !lastChecked.current) {
      fieldsData.forEach(function (item) {
        var children = item.children,
            groupId = item.groupId,
            fieldId = item.fieldId;
        var key = isMultipleDragGroup ? groupId || fieldId : 'group';
        var selectFieldId = checkedValueMap.get(key) || [];
        var value = getFilterData(children, checkedValueMap.get(key));
        (value === null || value === void 0 ? void 0 : value.length) && checkedValueMap.set(key, _toConsumableArray(new Set(selectFieldId.concat(value))));
      });
      lastChecked.current = true;
    } else {
      fieldsData.forEach(function (item) {
        var _checkedValueMap$get;

        var groupId = item.groupId,
            fieldId = item.fieldId;
        var key = isMultipleDragGroup ? groupId || fieldId : 'group';
        var retainFields = (_checkedValueMap$get = checkedValueMap.get(key)) === null || _checkedValueMap$get === void 0 ? void 0 : _checkedValueMap$get.filter(function (obj) {
          return disableFields.includes(obj);
        });

        if (retainFields !== null && retainFields !== void 0 && retainFields.length) {
          checkedValueMap.set(key, retainFields);
        } else {
          checkedValueMap.delete(key);
        }
      });
      lastChecked.current = false;
    }

    setCheckedValueMap(new Map(checkedValueMap));
  };

  var _useMemo2 = useMemo(function () {
    var size = checkedValueMap.size;
    var checkedAll;

    if (isMultipleDragGroup) {
      checkedAll = fieldsData.every(function (item) {
        var _checkedValueMap$get2;

        var children = item.children,
            groupId = item.groupId,
            fieldId = item.fieldId;
        var key = groupId || fieldId;
        return (((_checkedValueMap$get2 = checkedValueMap.get(key)) === null || _checkedValueMap$get2 === void 0 ? void 0 : _checkedValueMap$get2.length) || 0) >= ((children === null || children === void 0 ? void 0 : children.length) || 0);
      });
    } else {
      var _checkedValueMap$get3;

      var fieldsDataLength = fieldsData.reduce(function (total, item) {
        var children = item.children;
        return total + ((children === null || children === void 0 ? void 0 : children.length) || 0);
      }, 0);
      var selectFieldIdLen = ((_checkedValueMap$get3 = checkedValueMap.get('group')) === null || _checkedValueMap$get3 === void 0 ? void 0 : _checkedValueMap$get3.length) || 0;
      checkedAll = fieldsDataLength <= selectFieldIdLen;
    }

    var indeterminate = size > 0 && !checkedAll;
    return {
      indeterminate: indeterminate,
      checkedAll: checkedAll
    };
  }, [checkedValueMap]),
      indeterminate = _useMemo2.indeterminate,
      checkedAll = _useMemo2.checkedAll;

  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header")
  }, /*#__PURE__*/React.createElement(Checkbox, {
    style: {
      width: 135
    },
    indeterminate: indeterminate,
    checked: checkedAll,
    onChange: checkedAllOnChange
  }, "\u5168\u9009\u5206\u7EC4"), /*#__PURE__*/React.createElement("span", {
    style: {
      marginTop: 3
    }
  }, "\u5B57\u6BB5")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-container")
  }, fieldsData === null || fieldsData === void 0 ? void 0 : fieldsData.map(function (item, index) {
    return /*#__PURE__*/React.createElement(FieldItem, _extends({
      key: index
    }, item));
  })));
};