import React, { useMemo, useRef } from 'react';
import { Checkbox } from 'rlj-design';
import { useStoreContext } from "../hooks";
import { useFieldsToOptions } from "../hooks/useFieldsToOptions";
import { PREFIX_CLS } from "../../constants/dictionary";
import "../style/fieldCheckbox.less";
var CheckboxGroup = Checkbox.Group;
export var FieldSingleCheckbox = function FieldSingleCheckbox() {
  var prefixCls = "".concat(PREFIX_CLS, "-fieldSingleCheckbox");

  var _useStoreContext = useStoreContext(),
      fieldsData = _useStoreContext.fieldsData,
      checkedValueMap = _useStoreContext.checkedValueMap,
      setCheckedValueMap = _useStoreContext.setCheckedValueMap,
      unDisableFields = _useStoreContext.unDisableFields,
      disableFields = _useStoreContext.disableFields;

  var lastChecked = useRef(false);

  var onChange = function onChange(e) {
    var _e$target = e.target,
        value = _e$target.value,
        checked = _e$target.checked;
    var selectFieldId = checkedValueMap.get('single') || [];

    if (checked) {
      checkedValueMap.set('single', selectFieldId.concat([value]));
    } else {
      checkedValueMap.set('single', selectFieldId.filter(function (item) {
        return item !== value;
      }));
    }

    ;
    setCheckedValueMap(new Map(checkedValueMap));
  };

  var options = useFieldsToOptions(fieldsData, onChange);

  var checkedAllOnChange = function checkedAllOnChange(e) {
    var checked = e.target.checked;
    var selectFieldId = checkedValueMap.get('single') || [];

    if (checked && !lastChecked.current) {
      var list = Array.from(new Set(selectFieldId.concat(unDisableFields)));
      checkedValueMap.set('single', list);
      lastChecked.current = true;
    } else {
      var arrIntersection = selectFieldId.filter(function (item) {
        return disableFields.includes(item);
      });

      if (arrIntersection.length) {
        checkedValueMap.set('single', arrIntersection);
      } else {
        checkedValueMap.delete('single');
      }

      lastChecked.current = false;
    }

    setCheckedValueMap(new Map(checkedValueMap));
  };

  var _useMemo = useMemo(function () {
    var _checkedValueMap$get;

    var allLen = fieldsData.length;
    var curLen = ((_checkedValueMap$get = checkedValueMap.get('single')) === null || _checkedValueMap$get === void 0 ? void 0 : _checkedValueMap$get.length) || 0;
    return {
      indeterminate: curLen > 0 && curLen < allLen,
      checkedAll: curLen >= allLen
    };
  }, [checkedValueMap]),
      indeterminate = _useMemo.indeterminate,
      checkedAll = _useMemo.checkedAll;

  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header")
  }, /*#__PURE__*/React.createElement(Checkbox, {
    indeterminate: indeterminate,
    checked: checkedAll,
    onChange: checkedAllOnChange
  }, "\u5168\u9009\u5B57\u6BB5")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-container")
  }, /*#__PURE__*/React.createElement(CheckboxGroup, {
    options: options,
    value: checkedValueMap.get('single')
  })));
};