function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { useMemo, useState } from 'react';
export var useSigleDataHandle = function useSigleDataHandle(columns) {
  var _useState = useState(new Map(new Map([]))),
      _useState2 = _slicedToArray(_useState, 2),
      checkedValueMap = _useState2[0],
      setCheckedValueMap = _useState2[1];

  var _useMemo = useMemo(function () {
    var disableFields = [];
    var unDisableFields = [];
    columns === null || columns === void 0 ? void 0 : columns.forEach(function (_ref) {
      var fieldDisabled = _ref.fieldDisabled,
          fieldId = _ref.fieldId,
          checkable = _ref.checkable;

      if (fieldDisabled || checkable === false) {
        disableFields.push(fieldId);
      } else {
        unDisableFields.push(fieldId);
      }
    });
    return {
      disableFields: disableFields,
      unDisableFields: unDisableFields
    };
  }, [columns]),
      disableFields = _useMemo.disableFields,
      unDisableFields = _useMemo.unDisableFields;

  var _useMemo2 = useMemo(function () {
    var selectTemp = [];
    var selectFieldId = checkedValueMap.get('single') || [];
    columns === null || columns === void 0 ? void 0 : columns.forEach(function (item) {
      var fieldId = item.fieldId;
      var index = selectFieldId.indexOf(fieldId);
      if (index > -1) selectTemp[index] = item;
    });
    return {
      selectFields: selectTemp.filter(function (_ref2) {
        var status = _ref2.status;
        return status !== 'remove';
      }),
      selectAllFields: selectTemp,
      selectFieldId: selectFieldId
    };
  }, [checkedValueMap]),
      selectFields = _useMemo2.selectFields,
      selectFieldId = _useMemo2.selectFieldId,
      selectAllFields = _useMemo2.selectAllFields;

  return {
    fieldsData: columns,
    disableFields: disableFields,
    unDisableFields: unDisableFields,
    selectFields: selectFields,
    selectAllFields: selectAllFields,
    selectFieldId: selectFieldId,
    checkedValueMap: checkedValueMap,
    setCheckedValueMap: setCheckedValueMap
  };
};