var _excluded = ["loadingImg", "loadingTip", "percent", "onComplete", "speed", "finishRender"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect } from 'react';
import TweenOne from 'rc-tween-one';
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-progressPro");

var ProgressPro = function ProgressPro(props) {
  var loadingImg = props.loadingImg,
      loadingTip = props.loadingTip,
      percent = props.percent,
      _onComplete = props.onComplete,
      speed = props.speed,
      finishRender = props.finishRender,
      restProps = _objectWithoutProperties(props, _excluded);

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      tipAnimation = _useState2[0],
      setTipAnimation = _useState2[1];

  var _useState3 = useState({}),
      _useState4 = _slicedToArray(_useState3, 2),
      loadingAnimation = _useState4[0],
      setLoadingAnimation = _useState4[1];

  var _useState5 = useState({}),
      _useState6 = _slicedToArray(_useState5, 2),
      resultAnimation = _useState6[0],
      setResultAnimation = _useState6[1];

  var _useState7 = useState(''),
      _useState8 = _slicedToArray(_useState7, 2),
      tip = _useState8[0],
      setTip = _useState8[1];

  var _useState9 = useState({
    opacity: 1,
    marginTop: 0
  }),
      _useState10 = _slicedToArray(_useState9, 2),
      style = _useState10[0],
      setStyle = _useState10[1];

  useEffect(function () {
    if (!loadingTip) return;

    if (loadingTip) {
      setTipAnimation([{
        opacity: 0,
        marginTop: -10,
        duration: 150,
        onComplete: function onComplete() {
          setTip(loadingTip);
          setStyle({
            opacity: 0,
            marginTop: 20
          });
          setTipAnimation([{
            opacity: 0,
            marginTop: 10,
            duration: 150
          }, {
            opacity: 1,
            marginTop: 0,
            duration: 150
          }]);
        }
      }]);
    }
  }, [loadingTip]);
  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-main'
  }, /*#__PURE__*/React.createElement(TweenOne, {
    animation: loadingAnimation
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-div'
  }, /*#__PURE__*/React.createElement("img", {
    className: prefixCls + '-div-img',
    src: loadingImg
  })), /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-loading'
  }, /*#__PURE__*/React.createElement(TweenOne, _extends({
    style: {
      width: percent + '%'
    },
    className: prefixCls + '-loading-bar',
    animation: {
      width: '100%',
      duration: speed * 1000,
      onComplete: function onComplete() {
        setLoadingAnimation({
          opacity: 0,
          duration: 500,
          onComplete: function onComplete() {
            setResultAnimation({
              display: 'block',
              duration: 500
            });
          }
        });
        _onComplete && _onComplete();
      }
    }
  }, restProps))), /*#__PURE__*/React.createElement("div", {
    className: prefixCls + '-loadingTip'
  }, /*#__PURE__*/React.createElement(TweenOne, {
    style: style,
    animation: tipAnimation,
    component: "p"
  }, tip)))), /*#__PURE__*/React.createElement(TweenOne, {
    className: prefixCls + '-result',
    animation: resultAnimation
  }, finishRender));
};

ProgressPro.defaultProps = {
  // needSwitch: true,
  speed: 5,
  percent: 0,
  loadingTip: '',
  loadingImg: 'https://img.renlijia.com/202303/RLJJ7Blp61gMhW947LKc9A21oH-600-300.gif'
};
export default ProgressPro;