function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import { Icon } from 'rlj-design';
import classnames from 'classnames';
import { SortContext } from "./Sort";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/sortBtn.less";
var prefixCls = "".concat(PREFIX_CLS, "-sort-btn");

var SortBtn = function SortBtn(_ref) {
  var _classnames;

  var children = _ref.children,
      open = _ref.open,
      setOpen = _ref.setOpen,
      style = _ref.style;

  var _ref2 = useContext(SortContext) || {},
      hasData = _ref2.hasData;

  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefixCls, (_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-hover"), !(open || hasData)), _defineProperty(_classnames, "".concat(prefixCls, "-click"), open || hasData), _classnames)),
    onClick: function onClick() {
      return setOpen(!open);
    },
    style: style
  }, /*#__PURE__*/React.createElement(Icon, {
    style: {
      marginRight: 4
    },
    type: "sort"
  }), children);
};

export default SortBtn;