function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import Item from "../item";
import { getNormalDpi, getKey } from "../../../utils/tools";
import { ExcelContext } from "../../../index";
import { DataCompCxt } from "../../index";
import getColumns from "./getColumns";
import "./index.less";

var StickyColumns = function StickyColumns(props) {
  var minRow = props.minRow,
      maxRow = props.maxRow,
      type = props.type,
      containerHeight = props.containerHeight; // type传值只能是left和right

  var isRight = type === 'right';

  var _ref = useContext(ExcelContext),
      columnInfo = _ref.columnInfo,
      dataSource = _ref.dataSource;

  var _ref2 = useContext(DataCompCxt),
      rowHeight = _ref2.rowHeight;

  var fixedRight = columnInfo.fixedRight,
      fixedLeft = columnInfo.fixedLeft;
  var sourceDate = isRight ? fixedRight : fixedLeft;
  var stickyWidth = sourceDate.res;

  var sideStyle = _objectSpread({
    width: stickyWidth - (!getNormalDpi() && isRight ? 1 : 0),
    height: containerHeight
  }, _defineProperty({}, type, 0)); // 数据行 数组


  var sideRows = getColumns(minRow, maxRow, rowHeight, stickyWidth, dataSource);
  return /*#__PURE__*/React.createElement("div", {
    className: "salaryExcelStickyColBox",
    style: sideStyle
  }, sideRows.map(function (_ref3) {
    var data = _ref3.data,
        index = _ref3.index,
        style = _ref3.style;
    return /*#__PURE__*/React.createElement("div", {
      style: style,
      key: index,
      className: "stickyColInner"
    }, sourceDate.data.map(function (currentColumn, ii) {
      return /*#__PURE__*/React.createElement(Item, {
        key: getKey(currentColumn),
        rowIndex: index,
        columnIndex: ii // 在左右固定列的第几列
        ,
        currentColumn: currentColumn,
        currentData: data
      });
    }));
  }));
};

export default StickyColumns;