function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { Pagination } from 'rlj-design';
import "./index.less";
export default function Footer(props) {
  var tableCb = props.tableCb,
      pagination = props.pagination;
  var _pagination$onShowSiz = pagination.onShowSizeChange,
      onShowSizeChange = _pagination$onShowSiz === void 0 ? function () {} : _pagination$onShowSiz,
      _pagination$onChange = pagination.onChange,
      onChange = _pagination$onChange === void 0 ? function () {} : _pagination$onChange;

  var paginationSizeChange = function paginationSizeChange(current, size) {
    if (size === pagination.pageSize) return;
    onShowSizeChange(current, size);
    tableCb({
      current: current,
      pageSize: size
    });
  };

  var paginationChange = function paginationChange(page, pageSize) {
    if (page === pagination.current) return;
    onChange(page, pageSize);
    tableCb({
      current: page,
      pageSize: pageSize
    });
  };

  if (Pagination && pagination.total > 0) {
    return /*#__PURE__*/React.createElement("div", {
      className: "tExcel-pagination-box"
    }, /*#__PURE__*/React.createElement(Pagination, _extends({
      size: "small",
      className: "tExcel-pagination"
    }, pagination, {
      onShowSizeChange: paginationSizeChange,
      onChange: paginationChange,
      showSizeChanger: pagination.showSizeChanger !== false,
      hideOnSinglePage: false //强制false，原因：切换单页条数后，可能导致只有一页数据，此时如果该参数为true，就不能再切换单页数
      ,
      pageSizeOptions: ['30', '50', '100'] //pageSize必须是string，number会导致显示时没有（条/页）

    })));
  }

  return null;
}